## START: Set by rpmautospec
## (rpmautospec version 0.6.0)
## RPMAUTOSPEC: autorelease, autochangelog
%define autorelease(e:s:pb:n) %{?-p:0.}%{lua:
    release_number = 2;
    base_release_number = tonumber(rpm.expand("%{?-b*}%{!?-b:1}"));
    print(release_number + base_release_number - 1);
}%{?-e:.%{-e*}}%{?-s:.%{-s*}}%{!?-n:%{?dist}}
## END: Set by rpmautospec

# TODO: Package extra and review tests once `crick` and `distributed`
#       are available.

%global pypi_name dask-expr
%global forgeurl https://github.com/dask/dask-expr

# dask-expr buildrequires dask, and dask buildrequires dask-expr
# this disables dask-expr's tests and excludes dask from the
# buildrequires, for breaking the loop when bootstrapping
%bcond bootstrap 0

# Tests require `distributed` and so does `dask_expr`. But that
# dependency is neither listed nor available, yet.
%bcond tests 1

Name:           python-%{pypi_name}
Version:        1.1.6
Release:        %{autorelease}
Summary:        High Level Expressions for Dask
%forgemeta
License:        BSD-3-Clause
URL:            %forgeurl
Source:         %forgesource

BuildArch:      noarch
BuildRequires:  python3-devel
BuildRequires:  git-core
# Unlisted and unavailable dependencies
# https://github.com/dask/dask-expr/issues/1079
#BuildRequires:  python3dist(distributed)
#BuildRequires:  python3dist(crick)
%if %{with tests}
BuildRequires:  python3dist(pytest)
%endif

%global _description %{expand:
Dask Expressions - Dask DataFrames with query optimization.

This is a rewrite of Dask DataFrame that includes query optimization
and generally improved organization.}

%description %_description


%package -n python3-%{pypi_name}
Summary:        %{summary}
# Unlisted and unavailable dependencies
# https://github.com/dask/dask-expr/issues/1079
#Requires:       python3dist(distributed)
#Requires:       python3dist(crick)

%description -n python3-%{pypi_name} %_description


%prep
%forgeautosetup -p1 -S git

%if %{with bootstrap}
# patch out the dask dependency so we can bootstrap it
sed -r -i '/(dask)[<=> ]+[0-9]+/d' pyproject.toml
%else
# Drop upper bound from dask
sed -r -i 's/(dask)[<=> ]*[0-9.]*/\1/' pyproject.toml
%endif

# Loosen version pinning on versioneer[toml]
sed -r -i 's/(versioneer\[toml\])[<=>]*/\1>=/' pyproject.toml

# Commit and tag for Versioneer
git add --all
git commit -m '[Fedora] Changes for RPM'
git tag v%{version}


%generate_buildrequires
%pyproject_buildrequires


%build
%pyproject_wheel


%install
%pyproject_install
%pyproject_save_files -l dask_expr


%check

%if %{with tests} && %{without bootstrap}

# ImportError: Dask diagnostics requirements are not installed
k="${k-}${k+ and }not test_df_to_html"
# Test needs `distributed` and is not covered by `1081.patch`.
k="${k-}${k+ and }not test_respect_context_shuffle"
# Tests keep failing on `s390x`. Probably NumPy related.
k="${k-}${k+ and }not test_combine_similar_no_projection_on_one_branch"
k="${k-}${k+ and }not test_parquet_all_na_column"
%pytest -v ${k+-k }"${k-}"

%else

# Skip `diagnostics` import. It requires `crick` and `distributed`.
# Neither is available in Fedora yet.
# https://github.com/dask/dask-expr/issues/1079
%pyproject_check_import -e '*diagnostics'

%endif


%files -n python3-%{pypi_name} -f %{pyproject_files}
%doc README.md


%changelog
## START: Generated by rpmautospec
* Fri Jun 21 2024 Packit <hello@packit.dev> - 1.1.6-1
- Update to 1.1.6 upstream release
- Resolves: rhbz#2293521

* Wed Jun 19 2024 Sandro <devel@penguinpee.nl> - 1.1.3-8
- Apply patch excluding tests requiring `distributed`

* Wed Jun 19 2024 Sandro <devel@penguinpee.nl> - 1.1.3-6
- Disable bootstrap, enable tests

* Wed Jun 19 2024 Sandro <devel@penguinpee.nl> - 1.1.3-5
- Revert "Build without bootstrap, but also without tests for now"

* Tue Jun 18 2024 Adam Williamson <awilliam@redhat.com> - 1.1.3-4
- Build without bootstrap, but also without tests for now

* Mon Jun 17 2024 Adam Williamson <awilliam@redhat.com> - 1.1.3-3
- Tweak the bootstrap implementation to be cleaner

* Mon Jun 17 2024 Adam Williamson <awilliam@redhat.com> - 1.1.3-2
- Filter dask dependency in bootstrap build

* Mon Jun 17 2024 Adam Williamson <awilliam@redhat.com> - 1.1.3-1
- Bump to 1.1.3, implement a bootstrap build to break dep loop

* Fri May 17 2024 Sandro <devel@penguinpee.nl> - 1.1.0-1
- Initial release (RHBZ#2280279)
## END: Generated by rpmautospec
